package com.jcg.example;

import com.jcg.example.employee.repository.EmployeeRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

@SpringBootApplication
public class SpringlikequeryApplication implements CommandLineRunner {

    // Main method
    public static void main(String[] args) {
        SpringApplication.run(SpringlikequeryApplication.class, args);
    }

    /*
    Using jdbc template

    Output:
    [Employee{id=2, name='Jane Doe', department='Marketing'}]
    [Employee{id=1, name='John Doe', department='Engineering'}, Employee{id=2, name='Jane Doe', department='Marketing'}]
     */

    @Autowired
    EmployeeRepository empRepo;

    @Override
    public void run(String... args) throws Exception {
        System.out.println(empRepo.findByNameLike("Jane"));
        System.out.println(empRepo.findByNameLike("Doe"));
    }

    /*
    Using JPA repository

    Output:
    [Product{id=1, name='Tablet1', category='Electronics'}, Product{id=2, name='Tablet1', category='Electronics'}]
    [Product{id=4, name='Desk', category='Furniture'}]
     */

    /*
    @Autowired
    ProductRepository productRepository;

    @Override
    public void run(String... args) throws Exception {
        System.out.println(productRepository.findByNameLike("Tablet"));
        System.out.println(productRepository.findByNameLike("Desk"));
    }
    */
}
