package com.jcg.example.employee.repository;

import com.jcg.example.employee.model.Employee;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public class EmployeeRepository {

    private final RowMapper<Employee> rowMapper = (rs, rowNum) -> {
        Employee employee = new Employee();
        employee.setId(rs.getLong("id"));
        employee.setName(rs.getString("name"));
        employee.setDepartment(rs.getString("department"));
        return employee;
    };

    @Autowired
    private JdbcTemplate jdbcTemplate;

    public List<Employee> findByNameLike(String namePattern) {
        String sql = "SELECT * FROM employees WHERE name LIKE ?";
        return jdbcTemplate.query(sql, new Object[]{"%" + namePattern + "%"}, rowMapper);
    }
}